Subject: Re: bug: keep_bootcon and early printk together can lead to (invisible) kernel panic

From: Aaro Koskinen <[email-masked]>
Date: Thu, 21 Feb 2013 17:46:12 +0200

On Thu, Feb 21, 2013 at 03:37:17PM +0100, Patrik, Kluba wrote:
> I had a silent lockup on one of our embedded system under development.
> It was not easy to track it down, so here's what I discovered, in case
> somebody runs into similar trouble.
> Using 'keep_bootcon' command line parameter, and enabling early printk
> can lead to a kernel panic. At least on MIPS, it does. The problem is
> that in arch/mips/kernel/early_printk.c everything is declared as
> __init and __initdata, so they are being freed, when the kernel
> frees .init.* sections. If 'keep_bootcon' is given, the early console
> does not get unregistered, and the entry in the console_drivers list
> can point (will, believe me) to garbage data. It's up to you to imagine
> the effects...

I also ran into this recently, this should fix it:

	http://marc.info/?l=linux-kernel&m=136062078931024&w=2

A.